#ifndef INTARRAY_H
#define INTARRAY_H

/* copyright 2021 university of freiburg */
/* author: Peter Thiemann <thiemann@informatik.uni-freiburg.de> */

/* dynamic array API */
/* element type int */

typedef struct _intarray intarray;

/* Funktionen: erzeugen, löschen, lesen, schreiben */
/* new int array of int, returns NULL if error */
intarray * ia_new(size_t initial_size, int default_value);

void ia_destroy(intarray * ia);

/* returns either value previously stored @i or the default given by new (does not resize) */
int ia_read(intarray * ia, size_t i);

/* write to arbitrary index i (resize if necessary) */
int ia_write(intarray * ia, size_t i, int val);

#endif // INTARRAY_H
